//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3D4041C0025C.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3D4041C0025C.cm

//## begin module%3D4041C0025C.cp preserve=no
//## end module%3D4041C0025C.cp

//## Module: ScaleParam%3D4041C0025C; Package specification
//## Subsystem: XSModel::Parameter%367691A8CEA0
//	/local/data/verisB/dorman/Xspec/src/XSModel/Parameter
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Parameter/ScaleParam.h

#ifndef SCALEPARAM_H
#define SCALEPARAM_H 1

//## begin module%3D4041C0025C.additionalIncludes preserve=no
//## end module%3D4041C0025C.additionalIncludes

//## begin module%3D4041C0025C.includes preserve=yes
//## end module%3D4041C0025C.includes

// Parameter
#include <XSModel/Parameter/Parameter.h>
//## begin module%3D4041C0025C.declarations preserve=no
//## end module%3D4041C0025C.declarations

//## begin module%3D4041C0025C.additionalDeclarations preserve=yes
//## end module%3D4041C0025C.additionalDeclarations


//## begin ScaleParam%38EB53E76DF0.preface preserve=yes
//## end ScaleParam%38EB53E76DF0.preface

//## Class: ScaleParam%38EB53E76DF0
//## Category: XSModel::Parameter%36349D8902D7
//## Subsystem: XSModel::Parameter%367691A8CEA0
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class ScaleParam : public Parameter  //## Inherits: <unnamed>%38EB53F7E248
{
  //## begin ScaleParam%38EB53E76DF0.initialDeclarations preserve=yes
  //## end ScaleParam%38EB53E76DF0.initialDeclarations

  public:
    //## Constructors (generated)
      ScaleParam(const ScaleParam &right);

    //## Constructors (specified)
      //## Operation: ScaleParam%3A92A28600FD
      ScaleParam (const string& initString = "", ComponentBase* p = 0	// Token for parent component instance for grabbing
      	// initialization data etc. Since there are (gain)
      	// parameters that do not have a component parent this is
      	// a pointer rather than a reference as used for the same
      	// concept for ComponentGroup and Component.
      );

      //## Operation: ScaleParam%3D6A38EE0337
      ScaleParam (const string& inputName, Real initial, ComponentBase* p = 0	// Token for parent component instance for grabbing
      	// initialization data etc. Since there are (gain)
      	// parameters that do not have a component parent this is
      	// a pointer rather than a reference as used for the same
      	// concept for ComponentGroup and Component.
      );

    //## Destructor (generated)
      virtual ~ScaleParam();


    //## Other Operations (specified)
      //## Operation: clone%38EB5764F328
      virtual ScaleParam* clone (ComponentBase* p) const;

      //## Operation: put%38EB66F57CF8
      virtual std::ostream& put (std::ostream& s) const;

      //## Operation: value%3900949D7DA8
      virtual Real value () const;

      //## Operation: stringVal%3CEC009F01F1
      //	Operation supporting the XSPEC tclout command which
      //	simply writes the data members of the parameter to a
      //	string.
      virtual string stringVal () const;

      //## Operation: parameterSetting%3F2E79C50232
      virtual string parameterSetting () const;

    // Additional Public Declarations
      //## begin ScaleParam%38EB53E76DF0.public preserve=yes
      //## end ScaleParam%38EB53E76DF0.public

  protected:

    //## Other Operations (specified)
      //## Operation: compare%38EB887C51C8
      virtual bool compare (const Parameter& right) const;

    // Additional Protected Declarations
      //## begin ScaleParam%38EB53E76DF0.protected preserve=yes
      //## end ScaleParam%38EB53E76DF0.protected

  private:
    //## Assignment Operation (generated)
      ScaleParam & operator=(const ScaleParam &right);


    //## Other Operations (specified)
      //## Operation: init%38ECDA677D98
      virtual void init (const string& initString);

      //## Operation: changeValue%38F64295DA98
      virtual void changeValue (const string& parString);

      //## Operation: setValue%3900953E5F50
      virtual void setValue (Real& val);

      //## Operation: doPreserve%3C0FD48B0341
      virtual void doPreserve ();

    // Additional Private Declarations
      //## begin ScaleParam%38EB53E76DF0.private preserve=yes
      //## end ScaleParam%38EB53E76DF0.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: factor%38EB57CDE008
      //## begin ScaleParam::factor%38EB57CDE008.attr preserve=no  private: Real {U} 0.
      Real m_factor;
      //## end ScaleParam::factor%38EB57CDE008.attr

    // Additional Implementation Declarations
      //## begin ScaleParam%38EB53E76DF0.implementation preserve=yes
      //## end ScaleParam%38EB53E76DF0.implementation

};

//## begin ScaleParam%38EB53E76DF0.postscript preserve=yes
//## end ScaleParam%38EB53E76DF0.postscript

// Class ScaleParam 

//## begin module%3D4041C0025C.epilog preserve=yes
//## end module%3D4041C0025C.epilog


#endif
